<template>
    <div class="team">
        <q-page class="row background-content">
            <div class="col-12">
                <div class="row q-px-md">
                    <div class="col-12">
                        <div
                            class="
                                page-content
                                no-scroll
                                items-center
                                q-pb-lg q-px-xl q-px-lg-xl q-px-xs-none
                            "
                        >
                            <!-- PENDING -->
                            <div class="row q-mt-lg pending">
                                <div class="col-md-4 col-12">
                                    <q-input
                                        outlined
                                        bottom-slots
                                        v-model="search"
                                        :label="$t('team.search')"
                                        :loading="state.loadingState"
                                        debounce="500"
                                        bg-color="transparent"
                                        clearable
                                        dense
                                        class="border-radius-10"
                                    >
                                        <template v-slot:prepend>
                                            <q-icon
                                                name="search"
                                                class="text-5B9ADD"
                                            />
                                        </template>
                                    </q-input>
                                </div>
                            </div>

                            <!-- PENDING LIST -->
                            <div class="row">
                                <div
                                    class="
                                        col-md-4 col-lg-3 col-12
                                        q-mt-md
                                        q-pr-md-md
                                        q-pb-sm-none
                                        q-pb-md-md
                                    "
                                    v-for="(member, index) in state.memberList"
                                    :key="'pending-' + index"
                                >
                                    <q-item
                                        dark
                                        bordered
                                        class="
                                            bg-member2
                                            my-card
                                            border-radius-15
                                        "
                                    >
                                        <q-item-section
                                            avatar
                                            class="q-py-sm"
                                            @click="pagePressed(member.id)"
                                        >
                                            <q-img
                                                class="
                                                    border-radius-50
                                                    opacity-5
                                                    pointer
                                                "
                                                :src="
                                                    member.user.imageUrl
                                                        ? member.user.imageUrl
                                                        : '/images/default.png'
                                                "
                                                width="50px"
                                                height="50px"
                                            />
                                        </q-item-section>
                                        <q-item-section>
                                            <div
                                                class="
                                                    invited-name
                                                    font-16
                                                    helvetica-neue-medium
                                                "
                                            >
                                                {{ member.user.name }}
                                            </div>
                                            <div
                                                class="
                                                    invited-status
                                                    text-subtitle2 text-A5B8FF
                                                    font-12
                                                    helvetica-neue-medium
                                                "
                                            >
                                                {{ $t('team.invited') }}
                                            </div>
                                        </q-item-section>
                                        <q-item-section side top>
                                            <q-btn
                                                size="sm"
                                                class="hoverLabel"
                                                title="Cancel"
                                                color="red"
                                                round
                                                flat
                                                icon="highlight_off"
                                            >
                                                <q-menu
                                                    cover
                                                    auto-close
                                                    class="border-radius-20"
                                                >
                                                    <q-list>
                                                        <q-item
                                                            clickable
                                                            @click="
                                                                removePendingMember(
                                                                    member.id
                                                                )
                                                            "
                                                        >
                                                            <q-item-section
                                                                avatar
                                                            >
                                                                <q-icon
                                                                    color="red"
                                                                    name="remove_circle"
                                                                />
                                                            </q-item-section>
                                                            <q-item-section>
                                                                {{
                                                                    $t(
                                                                        'button.remove'
                                                                    )
                                                                }}
                                                            </q-item-section>
                                                        </q-item>
                                                    </q-list>
                                                </q-menu>
                                            </q-btn>
                                        </q-item-section>
                                    </q-item>
                                </div>
                            </div>

                            <div
                                v-if="state.memberList.length < 1"
                                class="col-12"
                            >
                                <div
                                    class="
                                        q-mt-md-lg
                                        q-pt-md-lg
                                        q-mt-lg-xl
                                        q-pt-lg-xl
                                        text-center
                                    "
                                >
                                    <q-img
                                        src="/images/invite.png"
                                        width="45px"
                                        height="45px"
                                    />
                                    <p
                                        class="
                                            q-py-md
                                            helvetica-neue-light
                                            font-14
                                        "
                                    >
                                        {{ $t('invite.invitedUser') }}
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </q-page>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
import { useStore } from 'src/store';
import {
    defineComponent,
    ref,
    reactive,
    computed,
    watch,
    onMounted
} from 'vue';
import { MemberListResponseResult } from 'src/services/responses/member/MemberListResponse';
import { mapGetters } from 'vuex';

export default defineComponent({
    name: 'PendingList',
    computed: {
        ...mapGetters({
            getRoles: 'role/getRole'
        })
    },
    setup() {
        // store
        const store = useStore();

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        // data
        let search = ref('');

        let state = reactive({
            loadingState: ref(false),
            searchList: [] as any,
            memberList: computed(() => {
                return store.state.member.pendingList;
            }),
            roles: [] as any,
            currentPage: 'team-home',
            selectedMember: '',
            selectedMemberInfo: {} as any
        });

        // computed

        const memberPendingListRemoved = computed(() => {
            return store.state.member.pendingRemoved;
        });

        const roleList = computed(() => {
            return store.state.role.role;
        });

        // watch
        watch(search, async (currentValue) => {
            await searchFunction(currentValue);
            state.loadingState = false;
        });

        watch(memberPendingListRemoved, () => {
            store.commit('member/setPendingRemoved', false);
            updateMemberList(store.state.member.pendingList, 0);
        });

        // methods
        const searchFunction = async (search: string) => {
            if (store.state.role.permissions.member?.list) {
                state.loadingState = true;

                const result: MemberListResponseResult = await store.dispatch(
                    'member/getList',
                    {
                        status: 0,
                        keyword: search
                    }
                );

                if (result.members.length > 0) {
                    state.loadingState = false;
                    state.memberList = result.members;
                } else {
                    state.loadingState = false;
                }
            }
        };

        const getMembers = () => {
            state.memberList = store.state.member.pendingList;
        };

        const removePendingMember = async (id: string) => {
            if (store.state.role.permissions.member?.delete) {
                await store.dispatch('member/delete', {
                    type: 0,
                    memberId: id
                });
            }
        };

        const updateMemberList = (result: any, status: number) => {
            state.memberList = result;
        };

        const changeRole = async (role: any, memberId: string) => {
            if (store.state.role.permissions.member?.update) {
                await store.dispatch('member/update', {
                    memberId,
                    roleId: role.id
                });
            }
        };

        const selectCurrentPage = (page: string, member?: any) => {
            state.currentPage = page;
            state.selectedMember = member.id ?? '';
            state.selectedMemberInfo = member ?? '';
        };

        onMounted(getMembers);

        return {
            state,
            search,
            tab: ref('member'),
            dense: ref(true),
            getMembers,
            removePendingMember,
            roleList,
            changeRole,
            selectCurrentPage,
            selectedBusinessId
        };
    }
});
</script>
